﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace Better
{
    public class CRMPresentation
    {
        private CRMData _crmData;
        private CustomerSelector _customerSelector;

        public CRMPresentation(
            CRMData crmData,
            CustomerSelector customerSelector)
        {
            _crmData = crmData;
            _customerSelector = customerSelector;
        }

        public CRMData CRMData
        {
            get { return _crmData; }
        }

        public CustomerSelector CustomerSelector
        {
            get { return _customerSelector; }
        }

        public string MailMerge
        {
            get
            {
                Customer recipient =
                    _customerSelector.CurrentCustomer;
                if (recipient == null)
                {
                    return string.Empty;
                }
                else
                {
                    string name = recipient.Name;

                    return string.Format(
                        "Congratulations {0}, you are a winner!",
                        name);
                }
            }
        }

        public void NewCustomer()
        {
            _customerSelector.CurrentCustomer = _crmData.NewCustomer();
        }
    }
}
