﻿Imports System.ComponentModel

Public Class CRMPresentation
    Private _crmData As CRMData
    Private _customerSelector As CustomerSelector

    Public Sub New(ByVal crmData As CRMData, ByVal customerSelector As CustomerSelector)
        _crmData = crmData
        _customerSelector = customerSelector
    End Sub

    Public ReadOnly Property CRMData() As CRMData
        Get
            Return _crmData
        End Get
    End Property

    Public ReadOnly Property CustomerSelector() As CustomerSelector
        Get
            Return _customerSelector
        End Get
    End Property

    Public ReadOnly Property MailMerge() As String
        Get
            ' Calculate the new mail merge.
            Dim recipient As Customer
            recipient = _customerSelector.CurrentCustomer
            If recipient Is Nothing Then
                Return String.Empty
            Else
                Return String.Format( _
                    "Congratulations {0}, you are a winner!", _
                    recipient.Name)
            End If
        End Get
    End Property

    Public Sub NewCustomer()
        Dim newCustomer As New Customer

        newCustomer = _crmData.NewCustomer()
        _customerSelector.CurrentCustomer = newCustomer
    End Sub
End Class
